#include "StdAfx.h"
#include "PartitionImageShapeScriptletPlugin.h"
#include "XMLUtil.h"
#include "PartitionImageShape.h"

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_PARTITIONIMAGE_NODE, CPartitionImageShapeScriptletPlugin)
BOOL CPartitionImageShapeScriptletPlugin::ModifyComponent(CContainer* pParent, CComponent* pTarget, TiXmlElement* pNode)
{
	BOOL bSuccess = __super::ModifyComponent(pParent, pTarget, pNode);
	if (bSuccess)
	{
		CPartitionImageShape* pImageShape = reinterpret_cast<CPartitionImageShape*>(pTarget);
		if (pImageShape == NULL)
		{
			return FALSE;
		}
		TCHAR szValue[SCRIPTLET_MAX_VALUE] = {0};
		long lValue = 0;
		//part
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_PART_NODE), lValue) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_PART_NODE), lValue))
		{
			pImageShape->SetPartition(lValue);
		}
		//selectvisible
		if (XMLUtil::GetAttrValue(pNode, CT2CA(SCRIPTLET_SELECTVISIBLE_NODE), szValue, SCRIPTLET_MAX_VALUE) ||
			XMLUtil::GetValueAsAttr(pNode, CT2CA(SCRIPTLET_SELECTVISIBLE_NODE), szValue, SCRIPTLET_MAX_VALUE))
		{
			BOOL bSelectVisible = _tcsicmp(szValue, SCRIPTLET_TRUE_VALUE) == 0;
			pImageShape->SetSelectVisible(bSelectVisible);
		}
	}
	return bSuccess;
}
CComponent* CPartitionImageShapeScriptletPlugin::_CreateComponent(TiXmlElement* pNode)
{
	CComponent* pComponent = new CPartitionImageShape;

	return pComponent;
}

REGISTER_SCRIPTLETCOMPONENTPLUGIN_CREATOR(SCRIPTLET_PARTITIONTILEIMAGE_NODE, CPartitionTileImageShapeScriptletPlugin);
CComponent* CPartitionTileImageShapeScriptletPlugin::_CreateComponent(TiXmlElement* pNode)
{
	CComponent* pComponent = new CPartitionTileImageShape;

	return pComponent;
}